

sub Initialize_FontDB ()


	dim as integer FF, linelen, charIndexASC, dbIndex, i, pass
	FF = freefile
	
	dim as string fileline, m, charIndex, le
	
	dim as single cy, cx
	
	'for i =  32 to 128: print i;chr(i),;:next
	
	'480,579
	
	
	fontDB = Callocate( Sizeof( FontDBType ) * (26 + 10 + 10))
	'fontDB_G = Callocate( Sizeof( FontDBType ) * (26 + 10 + 10))
	
	open "data/font3d/fontData.dat" for input as #FF
	while not eof(FF)
		input #FF, fileline
		m = left(fileline, 1)
		linelen = len(fileline)
		
		if linelen = 1 then
			if m <> "'" then
			
				charIndex = m
				charIndexASC = asc(m)
				
				if charIndexASC > 64 and charIndexASC < 91 then
					dbIndex = charIndexASC - 65
					pass = 1
				elseif charIndex = "[" then
					dbIndex = 36
					pass = 1
				elseif charIndex = "]" then
					dbIndex = 37
					pass = 1
				elseif charIndex = "-" then
					dbIndex = 38
					pass = 1
				end if
				
				if pass = 1 then 
					if cy < 0 and cy > -3 then print "Font Load Error"
					cy = 4
					fontDB[dbIndex].Width = 0
					fontDB[dbIndex].DL = glGenLists(1)
					glNewList fontDB[dbIndex].DL, GL_COMPILE
				end if
				
			end if
		end if
		
		if linelen = 5 then
			if m <> "'" then
			
				for i = 0 to 4
					le = mid(fileline, i + 1, 1)
					fontdb_drawSegment le, cx, cy
					
					if le <> "0" and i > fontDB[dbIndex].Width then fontDB[dbIndex].Width = i
					cx += 1
				next
				
				cy -= 1
				cx = 0
				if cy = -3 then
					glEndList
				end if
				
			end if
		end if
		
	wend
	close #FF
	
	
	Initialize_FontDB_G
	
end sub




sub Initialize_FontDB_G ()


	dim as integer FF, linelen, charIndexASC, dbIndex, i, pass
	FF = freefile
	
	dim as string fileline, m, charIndex, le
	
	dim as single cy, cx
	
	'for i =  32 to 128: print i;chr(i),;:next
	
	'480,579
	
	dim as RGBAlpha color0, color1
	
	color0.R = 1
	color0.G = .97
	color0.B = .89
	
	
	color0.R = 1
	color0.G = 1
	color0.B = 1
	color0.A = 1
	color1.R = .71 / 3
	color1.G = .69 / 3
	color1.B = .63 / 3
	color1.A = 1
	
	
	fontDB_G = Callocate( Sizeof( FontDBType ) * (26 + 10 + 10))
	
	open "data/font3d/fontData.dat" for input as #FF
	while not eof(FF)
		input #FF, fileline
		m = left(fileline, 1)
		linelen = len(fileline)
		
		if linelen = 1 then
			if m <> "'" then
			
				charIndex = m
				charIndexASC = asc(m)
				
				if charIndexASC > 64 and charIndexASC < 91 then
					dbIndex = charIndexASC - 65
					pass = 1
				elseif charIndex = "[" then
					dbIndex = 36
					pass = 1
				elseif charIndex = "]" then
					dbIndex = 37
					pass = 1
				elseif charIndex = "-" then
					dbIndex = 38
					pass = 1
				end if
				
				if pass = 1 then 
					if cy < 0 and cy > -3 then print "Font Load Error"
					cy = 4
					fontDB_G[dbIndex].Width = 0
					fontDB_G[dbIndex].DL = glGenLists(1)
					glNewList fontDB_G[dbIndex].DL, GL_COMPILE
				end if
				
			end if
		end if
		
		if linelen = 5 then
			if m <> "'" then
			
				for i = 0 to 4
					le = mid(fileline, i + 1, 1)
					fontDB[dbIndex].blockData((-cy + 4) * 5 +cx) = le
					fontDB_G[dbIndex].color0((-cy + 4) * 5 +cx) = color0
					fontDB_G[dbIndex].color1((-cy + 4) * 5 +cx) = color1
					fontdb_drawSegment_grad le, cx, cy, color0, color1
					
					if le <> "0" and i > fontDB_G[dbIndex].Width then fontDB_G[dbIndex].Width = i
					cx += 1
				next
				
				cy -= 1
				cx = 0
				if cy = -3 then
					glEndList
				end if
				
			end if
		end if
		
	wend
	close #FF
	
	
end sub



sub fontdb_drawSegment (byval m as string, byval cx as single, byval cy as single)


	dim as integer curveSteps, c
	dim as single x0, y0, x1, y1, rad2
	
	rad2 = 3.14159 / 2
	
	curveSteps = 8
	
	'F'
	if m = "F" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(rad2 * c / curveSteps)
				y0 = cy + sin(rad2 * c / curveSteps)
			end if
			
			x1 = cx + cos(rad2 * (c + 1) / curveSteps)
			y1 = cy + sin(rad2 * (c + 1) / curveSteps)
			
			glNormal3f 0, 0, 1
			glVertex3f cx, cy, 0
			glVertex3f x0, y0, 0
			glVertex3f x1, y1, 0
		next
		glEnd
	end if
	
	'O'
	if m = "O" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(-rad2 + rad2 * c / curveSteps)
				y0 = cy + sin(-rad2 + rad2 * c / curveSteps) + 1
			end if
			
			x1 = cx + cos(-rad2 + rad2 * (c + 1) / curveSteps)
			y1 = cy + sin(-rad2 + rad2 * (c + 1) / curveSteps) + 1
			
			glNormal3f 0, 0, 1
			glVertex3f cx, cy + 1, 0
			glVertex3f x0, y0, 0
			glVertex3f x1, y1, 0
		next
		glEnd
	end if
	
	'W'
	if m = "W" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(-rad2 * 2 + rad2 * c / curveSteps) + 1
				y0 = cy + sin(-rad2 * 2 + rad2 * c / curveSteps) + 1
			end if
			
			x1 = cx + cos(-rad2 * 2 + rad2 * (c + 1) / curveSteps) + 1
			y1 = cy + sin(-rad2 * 2 + rad2 * (c + 1) / curveSteps) + 1
			
			glNormal3f 0, 0, 1
			glVertex3f cx + 1, cy + 1, 0
			glVertex3f x0, y0, 0
			glVertex3f x1, y1, 0
		next
		glEnd
	end if
	
	
	'T'
	if m = "T" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(rad2 + rad2 * c / curveSteps) + 1
				y0 = cy + sin(rad2 + rad2 * c / curveSteps)
			end if
			
			x1 = cx + cos(rad2 + rad2 * (c + 1) / curveSteps) + 1
			y1 = cy + sin(rad2 + rad2 * (c + 1) / curveSteps)
			
			glNormal3f 0, 0, 1
			glVertex3f cx + 1, cy, 0
			glVertex3f x0, y0, 0
			glVertex3f x1, y1, 0
		next
		glEnd
	end if
	
	
	
	'f'
	if m = "f" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(-rad2 * 2 + rad2 * c / curveSteps) + 1
				y0 = cy + sin(-rad2 * 2 + rad2 * c / curveSteps) + 1
			end if
			
			x1 = cx + cos(-rad2 * 2 + rad2 * (c + 1) / curveSteps) + 1
			y1 = cy + sin(-rad2 * 2 + rad2 * (c + 1) / curveSteps) + 1
			
			glNormal3f 0, 0, 1
			glVertex3f cx, cy, 0
			glVertex3f x1, y1, 0
			glVertex3f x0, y0, 0
		next
		glEnd
	end if
	
	'o'
	if m = "o" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(rad2 + rad2 * c / curveSteps) + 1
				y0 = cy + sin(rad2 + rad2 * c / curveSteps)
			end if
			
			x1 = cx + cos(rad2 + rad2 * (c + 1) / curveSteps) + 1
			y1 = cy + sin(rad2 + rad2 * (c + 1) / curveSteps)
			
			glNormal3f 0, 0, 1
			glVertex3f cx, cy + 1, 0
			glVertex3f x1, y1, 0
			glVertex3f x0, y0, 0
		next
		glEnd
	end if
	
	'w'
	if m = "w" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(rad2 * c / curveSteps)
				y0 = cy + sin(rad2 * c / curveSteps)
			end if
			
			x1 = cx + cos(rad2 * (c + 1) / curveSteps)
			y1 = cy + sin(rad2 * (c + 1) / curveSteps)
			
			glNormal3f 0, 0, 1
			glVertex3f cx + 1, cy + 1, 0
			glVertex3f x1, y1, 0
			glVertex3f x0, y0, 0
		next
		glEnd
	end if
	
	
	't'
	if m = "t" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(-rad2 + rad2 * c / curveSteps)
				y0 = cy + sin(-rad2 + rad2 * c / curveSteps) + 1
			end if
			
			x1 = cx + cos(-rad2 + rad2 * (c + 1) / curveSteps)
			y1 = cy + sin(-rad2 + rad2 * (c + 1) / curveSteps) + 1
			
			glNormal3f 0, 0, 1
			glVertex3f cx + 1, cy, 0
			glVertex3f x1, y1, 0
			glVertex3f x0, y0, 0
		next
		glEnd
	end if
	
	
	'B'
	if m = "B" then
		glBegin GL_TRIANGLES
			glVertex3f cx + 0, cy + 0, 0
			glVertex3f cx + 1, cy + 0, 0
			glVertex3f cx + 1, cy + 1, 0
			glVertex3f cx + 1, cy + 1, 0
			glVertex3f cx + 0, cy + 1, 0
			glVertex3f cx + 0, cy + 0, 0
		glEnd
	end if
	
	
end sub




sub fontdb_drawSegment_grad (byval m as string, byval cx as single, byval cy as single, color1 as RGBAlpha, color0 as RGBAlpha)


	dim as integer curveSteps, c
	dim as single x0, y0, x1, y1, rad2
	
	rad2 = 3.14159 / 2
	
	curveSteps = 8
	
	dim as single yratio
	
	'F'
	if m = "F" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(rad2 * c / curveSteps)
				y0 = cy + sin(rad2 * c / curveSteps)
			end if
			
			x1 = cx + cos(rad2 * (c + 1) / curveSteps)
			y1 = cy + sin(rad2 * (c + 1) / curveSteps)
			
			glNormal3f 0, 0, 1
			yratio = (cy + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx, cy, 0
			
			yratio = (y0 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x0, y0, 0
			
			yratio = (y1 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x1, y1, 0
		next
		glEnd
	end if
	
	'O'
	if m = "O" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(-rad2 + rad2 * c / curveSteps)
				y0 = cy + sin(-rad2 + rad2 * c / curveSteps) + 1
			end if
			
			x1 = cx + cos(-rad2 + rad2 * (c + 1) / curveSteps)
			y1 = cy + sin(-rad2 + rad2 * (c + 1) / curveSteps) + 1
			
			glNormal3f 0, 0, 1
			yratio = (cy + 4) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx, cy + 1, 0
			yratio = (y0 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x0, y0, 0
			yratio = (y1 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x1, y1, 0
		next
		glEnd
	end if
	
	'W'
	if m = "W" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(-rad2 * 2 + rad2 * c / curveSteps) + 1
				y0 = cy + sin(-rad2 * 2 + rad2 * c / curveSteps) + 1
			end if
			
			x1 = cx + cos(-rad2 * 2 + rad2 * (c + 1) / curveSteps) + 1
			y1 = cy + sin(-rad2 * 2 + rad2 * (c + 1) / curveSteps) + 1
			
			glNormal3f 0, 0, 1
			yratio = (cy + 4) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx + 1, cy + 1, 0
			yratio = (y0 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x0, y0, 0
			yratio = (y1 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x1, y1, 0
		next
		glEnd
	end if
	
	
	'T'
	if m = "T" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(rad2 + rad2 * c / curveSteps) + 1
				y0 = cy + sin(rad2 + rad2 * c / curveSteps)
			end if
			
			x1 = cx + cos(rad2 + rad2 * (c + 1) / curveSteps) + 1
			y1 = cy + sin(rad2 + rad2 * (c + 1) / curveSteps)
			
			glNormal3f 0, 0, 1
			yratio = (cy + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx + 1, cy, 0
			yratio = (y0 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x0, y0, 0
			yratio = (y1 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x1, y1, 0
		next
		glEnd
	end if
	
	
	
	'f'
	if m = "f" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(-rad2 * 2 + rad2 * c / curveSteps) + 1
				y0 = cy + sin(-rad2 * 2 + rad2 * c / curveSteps) + 1
			end if
			
			x1 = cx + cos(-rad2 * 2 + rad2 * (c + 1) / curveSteps) + 1
			y1 = cy + sin(-rad2 * 2 + rad2 * (c + 1) / curveSteps) + 1
			
			glNormal3f 0, 0, 1
			yratio = (cy + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx, cy, 0
			yratio = (y1 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x1, y1, 0
			yratio = (y0 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x0, y0, 0
		next
		glEnd
	end if
	
	'o'
	if m = "o" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(rad2 + rad2 * c / curveSteps) + 1
				y0 = cy + sin(rad2 + rad2 * c / curveSteps)
			end if
			
			x1 = cx + cos(rad2 + rad2 * (c + 1) / curveSteps) + 1
			y1 = cy + sin(rad2 + rad2 * (c + 1) / curveSteps)
			
			glNormal3f 0, 0, 1
			yratio = (cy + 4) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx, cy + 1, 0
			yratio = (y1 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x1, y1, 0
			yratio = (y0 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x0, y0, 0
		next
		glEnd
	end if
	
	'w'
	if m = "w" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(rad2 * c / curveSteps)
				y0 = cy + sin(rad2 * c / curveSteps)
			end if
			
			x1 = cx + cos(rad2 * (c + 1) / curveSteps)
			y1 = cy + sin(rad2 * (c + 1) / curveSteps)
			
			glNormal3f 0, 0, 1
			yratio = (cy + 4) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx + 1, cy + 1, 0
			yratio = (y1 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x1, y1, 0
			yratio = (y0 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x0, y0, 0
		next
		glEnd
	end if
	
	
	't'
	if m = "t" then
		glBegin GL_TRIANGLES
		for c = 0 to curveSteps - 1
			if c > 0 then
				x0 = x1
				y0 = y1
			else
				x0 = cx + cos(-rad2 + rad2 * c / curveSteps)
				y0 = cy + sin(-rad2 + rad2 * c / curveSteps) + 1
			end if
			
			x1 = cx + cos(-rad2 + rad2 * (c + 1) / curveSteps)
			y1 = cy + sin(-rad2 + rad2 * (c + 1) / curveSteps) + 1
			
			glNormal3f 0, 0, 1
			yratio = (cy + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx + 1, cy, 0
			yratio = (y1 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x1, y1, 0
			yratio = (y0 + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f x0, y0, 0
		next
		glEnd
	end if
	
	
	'B'
	if m = "B" then
		glBegin GL_TRIANGLES
			yratio = (cy + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx + 0, cy + 0, 0
			glVertex3f cx + 1, cy + 0, 0
			yratio = (cy + 4) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx + 1, cy + 1, 0
			glVertex3f cx + 1, cy + 1, 0
			glVertex3f cx + 0, cy + 1, 0
			yratio = (cy + 3) / 7
			glColor4f	color0.R + (color1.R - color0.R) * yratio,_
						color0.G + (color1.G - color0.G) * yratio,_
						color0.B + (color1.B - color0.B) * yratio,_
						color0.A + (color1.A - color0.A) * yratio
			glVertex3f cx + 0, cy + 0, 0
		glEnd
	end if
	
	
end sub






function fontdb_len (byval txt as string) as integer


	dim as integer lenx, i, mASC, dbIndex, w, totalW
	dim as string mm, m
	
	mm = ucase(txt)
	
	lenx = len(mm)
	
	for i = 0 to lenx - 1
		m = mid(mm, i + 1, 1)
		mASC = asc(m)
		dbIndex = -1
		if mASC > 64 and mASC < 91 then dbIndex = mASC - 65
		if m = "[" then dbIndex = 36
		if m = "]" then dbIndex = 37
		if m = "-" then dbIndex = 38
		if mASC = 32 then totalW += 5'gltranslatef 5, 0, 0
		if dbIndex > -1 then
			w = fontDB[dbIndex].Width
			
			totalW += w + 2
		end if
	
	next
	
	return totalW
	
end function




sub fontdb_print (byval txt as string)


	dim as integer lenx, i, mASC, dbIndex, w
	dim as string mm, m
	
	mm = ucase(txt)
	
	lenx = len(mm)
	
	glPushMatrix
	
	for i = 0 to lenx - 1
		m = mid(mm, i + 1, 1)
		mASC = asc(m)
		dbIndex = -1
		if mASC > 64 and mASC < 91 then dbIndex = mASC - 65
		if m = "[" then dbIndex = 36
		if m = "]" then dbIndex = 37
		if m = "-" then dbIndex = 38
		if mASC = 32 then gltranslatef 5, 0, 0
		if dbIndex > -1 then
			w = fontDB[dbIndex].Width
			
			glCallList fontDB[dbIndex].DL
			
			gltranslatef w + 2, 0, 0
		end if
	
	next
	
	
	glPopMatrix
	
end sub
	



sub fontdb_print_grad (byval txt as string)


	dim as integer lenx, i, mASC, dbIndex, w
	dim as string mm, m
	
	mm = ucase(txt)
	
	lenx = len(mm)
	
	glPushMatrix
	
	for i = 0 to lenx - 1
		m = mid(mm, i + 1, 1)
		mASC = asc(m)
		dbIndex = -1
		if mASC > 64 and mASC < 91 then dbIndex = mASC - 65
		if m = "[" then dbIndex = 36
		if m = "]" then dbIndex = 37
		if m = "-" then dbIndex = 38
		if mASC = 32 then gltranslatef 5, 0, 0
		if dbIndex > -1 then
			w = fontDB[dbIndex].Width
			
			glCallList fontDB_G[dbIndex].DL
			
			gltranslatef w + 2, 0, 0
		end if
	
	next
	
	
	glPopMatrix
	
end sub
	
	