sub PhaseEditor_Render_Gui_CoorBoxWindow ()

	dim as integer dropout
	dim as integer win, active
	dim as single alpha
	win = WIN_COOR_BOX
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = 0
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	
	dim as integer winX0, winY0, winW, winH
	winW = 300
	winH = 150
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, winY0 + 5, PhaseEditorGlobals.winCoorBox.title
	font_draw winX0 + 5, winY0 + 5, PhaseEditorGlobals.winCoorbox.title
	
	dim as single ret
	dim as integer pass
	dim as string text
	
	dim as integer rowHeight, curY
	rowHeight = 24
	curY = winY0 + 30
	
	dim as Vector3D displayCoor
	
	displayCoor.x = *PhaseEditorGlobals.winCoorBox.returnVal.x
	displayCoor.y = *PhaseEditorGlobals.winCoorBox.returnVal.y
	displayCoor.z = *PhaseEditorGlobals.winCoorBox.returnVal.z
	
	dim as single stp
	stp = .1
	if glfwGetKey(GLFW_KEY_LCTRL) then stp = 1
	if glfwGetKey(GLFW_KEY_LSHIFT) then stp = .01
	
	if glfwGetKey(asc("S")) then displayCoor.x -= stp * fpsr
	if glfwGetKey(asc("F")) then displayCoor.x += stp * fpsr
	if glfwGetKey(asc("E")) then displayCoor.y -= stp * fpsr
	if glfwGetKey(asc("D")) then displayCoor.y += stp * fpsr
	if glfwGetKey(asc("W")) then displayCoor.z -= stp * fpsr
	if glfwGetKey(asc("R")) then displayCoor.z += stp * fpsr
	
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw cx - PhaseEditorGlobals.winCoorBox.charLimit * 8 - 56, curY, "X:"
	PhaseEditor_Render_Gui_Button "S", cx - PhaseEditorGlobals.winCoorBox.charLimit * 8 - 33, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.x -= stp * fpsr
	PhaseEditor_Render_Gui_Textbox str(displayCoor.x), cx - PhaseEditorGlobals.winCoorBox.charLimit * 8, curY - 3, PhaseEditorGlobals.winCoorBox.charLimit * 8 * 2, win
	PhaseEditor_Render_Gui_Button "F", cx + PhaseEditorGlobals.winCoorBox.charLimit * 8 + 7, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.x += stp * fpsr
	PhaseEditor_Render_Gui_Button "0", cx + PhaseEditorGlobals.winCoorBox.charLimit * 8 + 40, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.x = 0
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw cx - PhaseEditorGlobals.winCoorBox.charLimit * 8 - 56, curY, "Y:"
	PhaseEditor_Render_Gui_Button "E", cx - PhaseEditorGlobals.winCoorBox.charLimit * 8 - 33, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.y -= stp * fpsr
	PhaseEditor_Render_Gui_Textbox str(displayCoor.y), cx - PhaseEditorGlobals.winCoorBox.charLimit * 8, curY - 3, PhaseEditorGlobals.winCoorBox.charLimit * 8 * 2, win
	PhaseEditor_Render_Gui_Button "D", cx + PhaseEditorGlobals.winCoorBox.charLimit * 8 + 7, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.y += stp * fpsr
	PhaseEditor_Render_Gui_Button "0", cx + PhaseEditorGlobals.winCoorBox.charLimit * 8 + 40, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.y = 0
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw cx - PhaseEditorGlobals.winCoorBox.charLimit * 8 - 56, curY, "Z:"
	PhaseEditor_Render_Gui_Button "W", cx - PhaseEditorGlobals.winCoorBox.charLimit * 8 - 33, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.z -= stp * fpsr
	PhaseEditor_Render_Gui_Textbox str(displayCoor.z), cx - PhaseEditorGlobals.winCoorBox.charLimit * 8, curY - 3, PhaseEditorGlobals.winCoorBox.charLimit * 8 * 2, win
	PhaseEditor_Render_Gui_Button "R", cx + PhaseEditorGlobals.winCoorBox.charLimit * 8 + 7, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.z += stp * fpsr
	PhaseEditor_Render_Gui_Button "0", cx + PhaseEditorGlobals.winCoorBox.charLimit * 8 + 40, curY - 3, 26, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then displayCoor.z = 0
	
	*PhaseEditorGlobals.winCoorBox.returnVal.x = displayCoor.x
	*PhaseEditorGlobals.winCoorBox.returnVal.y = displayCoor.y
	*PhaseEditorGlobals.winCoorBox.returnVal.z = displayCoor.z
	
	'-65 to -5
	'-135 to -75
	'5 to 65
	'75 to 135
	
	PhaseEditor_Render_Gui_Button "OK", cx - 135, winY0 + winH - 25, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		dropout = 1
		'*PhaseEditorGlobals.winCoorBox.returnValue = PhaseEditorGlobals.winCoorBox.value
		if PhaseEditorGlobals.winCoorBox.returnWindow = WIN_MESH_PROPERTIES then PhaseEditorGlobals.winMeshProperties.forceRegen = 1
	end if
	
	PhaseEditor_Render_Gui_Button "APPLY", cx - 65, winY0 + winH - 25, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		'dropout = 1
		'*PhaseEditorGlobals.winCoorBox.returnValue = PhaseEditorGlobals.winCoorBox.value
		if PhaseEditorGlobals.winCoorBox.returnWindow = WIN_MESH_PROPERTIES then PhaseEditorGlobals.winMeshProperties.forceRegen = 1
	end if
	
	PhaseEditor_Render_Gui_Button "RESET", cx + 5, winY0 + winH - 25, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		'dropout = 1
		*PhaseEditorGlobals.winCoorBox.returnVal.x = PhaseEditorGlobals.winCoorBox.originalVal.x
		*PhaseEditorGlobals.winCoorBox.returnVal.y = PhaseEditorGlobals.winCoorBox.originalVal.y
		*PhaseEditorGlobals.winCoorBox.returnVal.z = PhaseEditorGlobals.winCoorBox.originalVal.z
		if PhaseEditorGlobals.winCoorBox.returnWindow = WIN_MESH_PROPERTIES then PhaseEditorGlobals.winMeshProperties.forceRegen = 1
	end if
	
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 75, winY0 + winH - 25, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		dropout = 1
		*PhaseEditorGlobals.winCoorBox.returnVal.x = PhaseEditorGlobals.winCoorBox.originalVal.x
		*PhaseEditorGlobals.winCoorBox.returnVal.y = PhaseEditorGlobals.winCoorBox.originalVal.y
		*PhaseEditorGlobals.winCoorBox.returnVal.z = PhaseEditorGlobals.winCoorBox.originalVal.z
		if PhaseEditorGlobals.winCoorBox.returnWindow = WIN_MESH_PROPERTIES then PhaseEditorGlobals.winMeshProperties.forceRegen = 1
	end if
	
	if dropout = 1 then 
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(PhaseEditorGlobals.winCoorBox.returnWindow) = 0
	end if
	
end sub



sub PhaseEditor_Window_Init_CoorBoxWindow (limit as integer)

	PhaseEditorGlobals.winCoorBox.charLimit = limit
	PhaseEditorGlobals.winCoorBox.originalVal.x = *PhaseEditorGlobals.winCoorBox.returnVal.x
	PhaseEditorGlobals.winCoorBox.originalVal.y = *PhaseEditorGlobals.winCoorBox.returnVal.y
	PhaseEditorGlobals.winCoorBox.originalVal.z = *PhaseEditorGlobals.winCoorBox.returnVal.z
	
end sub