sub PhaseMenu_Render_Gui_Credits ()


	dim as integer win, active
	dim as single alpha
	win = WIN_CREDITS
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy, i
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer buttonheight, curY
	dim as integer winX0, winY0, winW, winH
	winW = 428
	winH = 348
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	
	PhaseEditor_Render_Gui_WindowGame winX0, winY0, winX0 + winW, winY0 + winH, PEC_TEXTBOX_BG, PMC_WINDOW_BG_DARK, win
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, winY0 + 5, "CREDITS"
	font_draw winX0 + 5, winY0 + 5, "CREDITS"
	
	dim as integer w, h
	dim as string gcTitle(11)

	gcTitle(0) = "Programming - Daniel Kennedy (syn9)"
	gcTitle(1) = "Game Engine - syn9"
	gcTitle(2) = "3D Models - syn9"
	gcTitle(3) = "Music & Sound FX - syn9"
	gcTitle(4) = "Game Design - syn9"
	gcTitle(5) = "Assistant Game Design - Quinton Roberts (Eclipzer)"
	gcTitle(6) = "Game Clock - Eclipzer"
	gcTitle(7) = "OBJ Model Loader - syn9 / Dr_D"
	gcTitle(8) = "Beta Testing - Eclipzer / Deleter"
	gcTitle(9) = "- Shout Outs -"
	gcTitle(10) = "Eclipzer, v1ctor, Topa, Aenyn, Rel, Alias, Lachie, Marcade"
	gcTitle(11) = "Deleter, HexDude, Kiz, BadMrBox, Cha0s, SSC, Pete, bje990"

	curY = winY0 + 30
	for i = 0 to 11
		font_xy w, h, gcTitle(i)
		font_draw cx - w / 2, curY, gcTitle(i)
		font_draw cx - w / 2, curY, gcTitle(i)
		curY += 24
	next
	
	
	PhaseEditor_Render_Gui_Button "MAIN", cx - 35, winY0 + winH - 25, 70, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_MAIN) = 0
		
		if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
			PhasePlayerGlobals.musicChannel(MH_COCK) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_COCK))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_COCK), PhaseMenuGlobals.winOptions.sfxVol
		end if
	end if

	
end sub
