sub PhaseMenu_Render_Gui_HSData ()


	dim as integer win, active
	dim as single alpha
	win = WIN_HS_DATA
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy, i
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer winX0, winY0, winW, winH
	winW = 300
	winH = 386 -57
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	'PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	PhaseEditor_Render_Gui_WindowGame winX0, winY0, winX0 + winW, winY0 + winH, PEC_TEXTBOX_BG, PMC_WINDOW_BG_DARK, win
	
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, winY0 + 5, "HIGH SCORE DATA"
	font_draw winX0 + 5, winY0 + 5, "HIGH SCORE DATA"
	
	dim as integer rowHeight, curY, buttonX
	rowHeight = 24
	curY = winY0 + 30
	
	buttonX = 150
	
	dim as string gcTitle
	dim as integer w, h, hs
	dim as HighScoreType ptr score
	
	hs = PhaseMenuGlobals.winHSData.hs
	score = @PhasePlayerGlobals.player.highScores(hs)
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Player Name:"
	gcTitle = score->name
	
	font_xy w, h, gcTitle
	if w > 120 then
		for i = 1 to len(gcTitle)
			font_xy w, h, gcTitle
			if w > 120 then
				gcTitle = left(gcTitle, len(gcTitle) - 1)
			else
				gcTitle += "..."
				goto contin2
			end if
		next
	end if
	
contin2:
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	PhaseEditor_Render_Gui_Textbox gcTitle, cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Score:"
	PhaseEditor_Render_Gui_Textbox str(score->points + int(score->timeBonus * score->points)), cx, curY - 3, 0, win
	
	curY += rowHeight * 2
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Enemy Kills:"
	PhaseEditor_Render_Gui_Textbox str(score->kills) + " (" + left(str(int(1000 * score->kills / score->totalSpawn)/10), 4) + "%)", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Enemy Damage:"
	PhaseEditor_Render_Gui_Textbox str(score->damage) + " (" + left(str(int(1000 * score->damage / score->totalHealth)/10), 4) + "%)", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "% Map Destroyed:"
	PhaseEditor_Render_Gui_Textbox left(str(int(1000 * score->mapDestroyed / score->totalProjectiles)/10), 4) + "%", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Power Ups Achieved:"
	PhaseEditor_Render_Gui_Textbox str(score->powerUps) + " (" + left(str(int(1000 * score->powerUps / score->totalPowerUps)/10), 4) + "%)", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Accuracy:"
	PhaseEditor_Render_Gui_Textbox left(str(int(1000 * score->accuracy)/10), 4) + "%", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Health Lost:"
	if score->healthLost = 500 then PhaseEditor_Render_Gui_Textbox "> 500", cx, curY - 3, 0, win
	if score->healthLost < 500 then PhaseEditor_Render_Gui_Textbox left(str(int(10 * score->healthLost) / 10), 4), cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Shield Lost:"
	if score->shieldLost = 500 then PhaseEditor_Render_Gui_Textbox "> 500", cx, curY - 3, 0, win
	if score->shieldLost < 500 then PhaseEditor_Render_Gui_Textbox left(str(int(10 * score->shieldLost) / 10), 4), cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Time Bonus:"
	PhaseEditor_Render_Gui_Textbox str(int(score->timeBonus * score->points)), cx, curY - 3, 0, win
	
	
	PhaseEditor_Render_Gui_Button "HIGH SCORES", cx - 50, winY0 + winH - 25, 100, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_HIGH_SCORES) = 0
		
		if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
			PhasePlayerGlobals.musicChannel(MH_COCK) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_COCK))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_COCK), PhaseMenuGlobals.winOptions.sfxVol
		end if
	end if

end sub
