sub PhaseMenu_Render_Gui_NewHighScore ()


	dim as integer win, active
	dim as single alpha
	win = WIN_NEW_HIGH_SCORE
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy, i
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer winX0, winY0, winW, winH
	winW = 300
	winH = 386
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	'PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	PhaseEditor_Render_Gui_WindowGame winX0, winY0, winX0 + winW, winY0 + winH, PEC_TEXTBOX_BG, PMC_WINDOW_BG_DARK, win
	
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, winY0 + 5, "NEW HIGH SCORE"
	font_draw winX0 + 5, winY0 + 5, "NEW HIGH SCORE"
	
	dim as ScoreType ptr score
	score = @PhasePlayerGlobals.player.score
	
	dim as integer rowHeight, curY, buttonX
	rowHeight = 24
	curY = winY0 + 30
	
	buttonX = 150
	
	dim as string gcTitle
	dim as integer w, h
	
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Player Name:"
	gcTitle = "ENTER_NAME"
	if PhaseMenuGlobals.winNewHighScore.name <> "" then gcTitle = PhaseMenuGlobals.winNewHighScore.name
	
	font_xy w, h, gcTitle
	if w > 120 then
		for i = 1 to len(gcTitle)
			font_xy w, h, gcTitle
			if w > 120 then
				gcTitle = left(gcTitle, len(gcTitle) - 1)
			else
				gcTitle += "..."
				goto contin
			end if
		next
	end if
	
contin:
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	PhaseEditor_Render_Gui_Button gcTitle, cx, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_TEXT_BOX) = 1
		PhaseEditorGlobals.winTextbox.returnWindow = win
		PhaseEditorGlobals.winTextbox.returnValue = @PhaseMenuGlobals.winNewHighScore.name
		PhaseEditorGlobals.winTextbox.title = "Player Name"
		PhaseEditor_Window_Init_TextBoxWindow PhaseMenuGlobals.winNewHighScore.name, 24
	end if
	
	
	if PhasePlayerGlobals.player.gameOver < 3 then score->timeBonus = 0
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Score:"
	PhaseEditor_Render_Gui_Textbox str(score->points + int(score->timeBonus * score->points)), cx, curY - 3, 0, win
	
	curY += rowHeight * 2
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Enemy Kills:"
	PhaseEditor_Render_Gui_Textbox str(score->kills.value) + " (" + left(str(int(1000 * score->kills.value / PhaseDataGlobals.phaseSequence.totalSpawn)/10), 4) + "%)", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Enemy Damage:"
	PhaseEditor_Render_Gui_Textbox str(score->damage.value) + " (" + left(str(int(1000 * score->damage.value / PhaseDataGlobals.phaseSequence.totalHealth)/10), 4) + "%)", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "% Map Destroyed:"
	PhaseEditor_Render_Gui_Textbox left(str(int(1000 * score->mapDestroyed.value / PhaseDataGlobals.phaseSequence.totalProjectiles)/10), 4) + "%", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Power Ups Achieved:"
	PhaseEditor_Render_Gui_Textbox str(score->powerUps.value) + " (" + left(str(int(1000 * score->powerUps.value / PhaseDataGlobals.phaseSequence.totalPowerUps)/10), 4) + "%)", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Accuracy:"
	PhaseEditor_Render_Gui_Textbox left(str(int(1000 * score->accuracy.value)/10), 4) + "%", cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Health Lost:"
	if score->healthLost.value = 500 then PhaseEditor_Render_Gui_Textbox "> 500", cx, curY - 3, 0, win
	if score->healthLost.value < 500 then PhaseEditor_Render_Gui_Textbox left(str(int(10 * score->healthLost.value) / 10), 4), cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Shield Lost:"
	if score->shieldLost.value = 500 then PhaseEditor_Render_Gui_Textbox "> 500", cx, curY - 3, 0, win
	if score->shieldLost.value < 500 then PhaseEditor_Render_Gui_Textbox left(str(int(10 * score->shieldLost.value) / 10), 4), cx, curY - 3, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Time Bonus:"
	PhaseEditor_Render_Gui_Textbox str(int(score->timeBonus * score->points)), cx, curY - 3, 0, win
	
	
	curY += rowHeight * 2
	gcTitle = "SAVE MY HIGH SCORE ONLINE"
	font_xy w, h, gcTitle
	
	'PhaseEditor_Render_Gui_Button "SAVE MY HIGH SCORE ONLINE", cx - w / 2 - 5, curY - 3, 0, 0, win
	
	
	
	PhaseMenuGlobals.restart = 0
	PhaseEditor_Render_Gui_Button "SAVE", cx - 75, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winActive(WIN_HIGH_SCORES) = 1
		
		PhasePlayer_HighScores_Save
		PhasePlayer_HighScores_Load
		
		if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
			PhasePlayerGlobals.musicChannel(MH_COCK) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_COCK))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_COCK), PhaseMenuGlobals.winOptions.sfxVol
		end if
	end if
	
	
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 10, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_MAIN) = 0
		
		if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
			PhasePlayerGlobals.musicChannel(MH_COCK) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_COCK))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_COCK), PhaseMenuGlobals.winOptions.sfxVol
		end if
	end if
end sub
