#include once "ext/ext.bi"
using ext.math
using ext.gfx
'---------- fb specific
#INCLUDE "GL/gl.bi"
#INCLUDE "GL/glfw.bi"
#INCLUDE "GL/glu.bi"
#INCLUDE "GL/glext.bi"
#INCLUDE "crt.bi"
#INCLUDE "fbgfx.bi"
#INCLUDE "fbpng.bi"
'#INCLUDE "chisock/chisock.bi"
'using chi
#INCLUDE "fmod.bi"

RANDOMIZE TIMER

'---------- game includes
#INCLUDE "system.bi"
#INCLUDE "display.bi"
#INCLUDE "math.bi"
#INCLUDE "model_module.bi"
#INCLUDE "str_explode.bi"
#INCLUDE "font.bi"
#INCLUDE "fontdb.bi"
#include "physics.bi"
#INCLUDE "input.bi"
#INCLUDE "overload.bi"
#INCLUDE "shadow_volume.bi"
#INCLUDE "objFile.bi"



'---------- module includes
#INCLUDE "modules/GameClock.bi"
#INCLUDE "modules/PhaseData.bi"

#INCLUDE "modules/PhaseEditor.bi"
#INCLUDE "modules/PhaseEditor_Init_GeneratorClasses.bi"
#INCLUDE "modules/PhaseEditor_Init_WaveClasses.bi"
#INCLUDE "modules/PhaseEditor_Render_Scene.bi"

#INCLUDE "modules/PhasePlayer.bi"
#INCLUDE "modules/PhasePlayer_Init.bi"
#INCLUDE "modules/PhasePlayer_Bullets.bi"
#INCLUDE "modules/PhasePlayer_Explosions.bi"
#INCLUDE "modules/PhasePlayer_Missiles.bi"
#INCLUDE "modules/PhasePlayer_Projectiles.bi"
#INCLUDE "modules/PhasePlayer_Render_HUD.bi"
#INCLUDE "modules/PhasePlayer_Render_Scene.bi"
#INCLUDE "modules/PhasePlayer_Player.bi"
#INCLUDE "modules/PhasePlayer_Waves.bi"
#INCLUDE "modules/PhasePlayer_HighScores.bi"


#INCLUDE "modules/PhaseMenu.bi"
#INCLUDE "modules/PhasePause.bi"


'----------- game specific
#INCLUDE "display.bas"
#INCLUDE "math.bas"
#INCLUDE "model_module.bas"
#INCLUDE "initialize.bas"
#INCLUDE "system.bas"
#INCLUDE "font.bas"
#INCLUDE "fontdb.bas"
#INCLUDE "physics.bas"
#INCLUDE "input.bas"
#INCLUDE "shadow_volume.bas"


'----------- game modules
#INCLUDE "modules/PhaseData.bas"

#INCLUDE "modules/PhaseEditor.bas"
#INCLUDE "modules/PhaseEditor_Func.bas"
#INCLUDE "modules/PhaseEditor_Init_GeneratorClasses.bas"
#INCLUDE "modules/PhaseEditor_Init_WaveClasses.bas"
#INCLUDE "modules/PhaseEditor_Init.bas"
#INCLUDE "modules/PhaseEditor_Render_Scene.bas"

#INCLUDE "modules/PhasePlayer.bas"
#INCLUDE "modules/PhasePlayer_Init.bas"
#INCLUDE "modules/PhasePlayer_Bullets.bas"
#INCLUDE "modules/PhasePlayer_Explosions.bas"
#INCLUDE "modules/PhasePlayer_Missiles.bas"
#INCLUDE "modules/PhasePlayer_Projectiles.bas"
#INCLUDE "modules/PhasePlayer_Render_HUD.bas"
#INCLUDE "modules/PhasePlayer_Render_Scene.bas"
#INCLUDE "modules/PhasePlayer_Player.bas"
#INCLUDE "modules/PhasePlayer_Waves.bas"
#INCLUDE "modules/PhasePlayer_HighScores.bas"

#INCLUDE "modules/PhaseMenu.bas"
#INCLUDE "modules/PhasePause.bas"

'----------- editor windows
#INCLUDE "modules/Windows/Sequencer.bas"
#INCLUDE "modules/Windows/NewMesh.bas"
#INCLUDE "modules/Windows/NewPhase.bas"
#INCLUDE "modules/Windows/NewWave.bas"
#INCLUDE "modules/Windows/SelectTable.bas"
#INCLUDE "modules/Windows/SelectColor.bas"
#INCLUDE "modules/Windows/TextBox.bas"
#INCLUDE "modules/Windows/CoorBox.bas"
#INCLUDE "modules/Windows/NumberBox.bas"
#INCLUDE "modules/Windows/MeshProperties.bas"
#INCLUDE "modules/Windows/WaveProperties.bas"

'----------- game windows
#INCLUDE "modules/Windows/Main.bas"
#INCLUDE "modules/Windows/Options.bas"
#INCLUDE "modules/Windows/Credits.bas"
#INCLUDE "modules/Windows/Controls.bas"
#INCLUDE "modules/Windows/HighScores.bas"
#INCLUDE "modules/Windows/HSData.bas"
#INCLUDE "modules/Windows/NewHighScore.bas"
#INCLUDE "modules/Windows/SelectTableGame.bas"


'----------- paused windows
#INCLUDE "modules/Windows/PausedMain.bas"


Initialize

'PhaseEditor_LaunchApp
'Explosion_LaunchApp
PhaseMenu_LaunchApp


DeInit
