DECLARE function input_getControllerInput (inputControl as integer) as single


#DEFINE CONTROL_ROTATE_LEFT     0
#DEFINE CONTROL_ROTATE_RIGHT    1
#DEFINE CONTROL_STRAFE_LEFT     2
#DEFINE CONTROL_STRAFE_RIGHT    3
#DEFINE CONTROL_THRUST   		4
#DEFINE CONTROL_REVERSE    		5
#DEFINE CONTROL_LAND    		6
#DEFINE CONTROL_MISSION_WINDOW  7
#DEFINE CONTROL_ACCEPT  		7
#DEFINE CONTROL_MINIMAP			8
#DEFINE CONTROL_CANCEL			8
#DEFINE CONTROL_PREVWEAPON   	9
#DEFINE CONTROL_NEXTWEAPON   	10
#DEFINE CONTROL_USEWEAPON    	11


	

const CONTROL_NOTSET = 0
CONST CONTROL_JOY_B1 = 1, CONTROL_JOY_B2 = 2, CONTROL_JOY_B3 = 3, CONTROL_JOY_B4 = 4
CONST CONTROL_JOY_B5 = 5, CONTROL_JOY_B6 = 6, CONTROL_JOY_B7 = 7, CONTROL_JOY_B8 = 8
CONST CONTROL_JOY_B9 = 9, CONTROL_JOY_B10 = 10, CONTROL_JOY_B11 = 11, CONTROL_JOY_B12 = 12
CONST CONTROL_JOY_B13 = 13, CONTROL_JOY_B14 = 14, CONTROL_JOY_B15 = 15, CONTROL_JOY_B16 = 16

CONST CONTROL_AXIS_0_NEGATIVE = 17, CONTROL_AXIS_0_POSITIVE = 18
CONST CONTROL_AXIS_1_NEGATIVE = 19, CONTROL_AXIS_1_POSITIVE = 20
CONST CONTROL_AXIS_2_NEGATIVE = 21, CONTROL_AXIS_2_POSITIVE = 22
CONST CONTROL_AXIS_3_NEGATIVE = 23, CONTROL_AXIS_3_POSITIVE = 24
CONST CONTROL_AXIS_4_NEGATIVE = 25, CONTROL_AXIS_4_POSITIVE = 26
CONST CONTROL_AXIS_5_NEGATIVE = 27, CONTROL_AXIS_5_POSITIVE = 28

#DEFINE CONTROL_KB_A 29
#DEFINE CONTROL_KB_B 30
#DEFINE CONTROL_KB_C 31
#DEFINE CONTROL_KB_D 32
#DEFINE CONTROL_KB_E 33
#DEFINE CONTROL_KB_F 34
#DEFINE CONTROL_KB_G 35
#DEFINE CONTROL_KB_H 36
#DEFINE CONTROL_KB_I 37
#DEFINE CONTROL_KB_J 38
#DEFINE CONTROL_KB_K 39
#DEFINE CONTROL_KB_L 40
#DEFINE CONTROL_KB_M 41
#DEFINE CONTROL_KB_N 42
#DEFINE CONTROL_KB_O 43
#DEFINE CONTROL_KB_P 44
#DEFINE CONTROL_KB_Q 45
#DEFINE CONTROL_KB_R 46
#DEFINE CONTROL_KB_S 47
#DEFINE CONTROL_KB_T 48
#DEFINE CONTROL_KB_U 49
#DEFINE CONTROL_KB_V 50
#DEFINE CONTROL_KB_W 51
#DEFINE CONTROL_KB_X 52
#DEFINE CONTROL_KB_Y 53
#DEFINE CONTROL_KB_Z 54
#DEFINE CONTROL_KB_0 55
#DEFINE CONTROL_KB_1 56
#DEFINE CONTROL_KB_2 57
#DEFINE CONTROL_KB_3 58
#DEFINE CONTROL_KB_4 59
#DEFINE CONTROL_KB_5 60
#DEFINE CONTROL_KB_6 61
#DEFINE CONTROL_KB_7 62
#DEFINE CONTROL_KB_8 63
#DEFINE CONTROL_KB_9 64
#DEFINE CONTROL_KB_KP0 65
#DEFINE CONTROL_KB_KP1 66
#DEFINE CONTROL_KB_KP2 67
#DEFINE CONTROL_KB_KP3 68
#DEFINE CONTROL_KB_KP4 69
#DEFINE CONTROL_KB_KP5 70
#DEFINE CONTROL_KB_KP6 71
#DEFINE CONTROL_KB_KP7 72
#DEFINE CONTROL_KB_KP8 73
#DEFINE CONTROL_KB_KP9 74
#DEFINE CONTROL_KB_LCTRL    75
#DEFINE CONTROL_KB_RCTRL    76
#DEFINE CONTROL_KB_LSHIFT   77
#DEFINE CONTROL_KB_RSHIFT   78
#DEFINE CONTROL_KB_SPACE    79
#DEFINE CONTROL_KB_TAB      80
#DEFINE CONTROL_KB_RETURN   81
#DEFINE CONTROL_KB_LALT     82
#DEFINE CONTROL_KB_RALT     83
#DEFINE CONTROL_KB_UP       84
#DEFINE CONTROL_KB_DOWN     85
#DEFINE CONTROL_KB_LEFT     86
#DEFINE CONTROL_KB_RIGHT    87
#DEFINE CONTROL_KB_INSERT   88
#DEFINE CONTROL_KB_HOME     89
#DEFINE CONTROL_KB_END      90
#DEFINE CONTROL_KB_DELETE   91
#DEFINE CONTROL_KB_PAGEUP   92
#DEFINE CONTROL_KB_PAGEDOWN 93
#DEFINE CONTROL_KB_KP_PERIOD    94
#DEFINE CONTROL_KB_KP_DIVIDE    95
#DEFINE CONTROL_KB_KP_MULTIPLY  96
#DEFINE CONTROL_KB_KP_MINUS     97
#DEFINE CONTROL_KB_KP_PLUS      98
#DEFINE CONTROL_KB_KP_ENTER     99