

sub PhaseEditor_Init_New_Phase ()

	PhaseDataGlobals.PhaseSequence.roomClass = PhaseEditorGlobals.winNewPhase.roomClass
	PhaseDataGlobals.PhaseSequence.phaseTitle = PhaseEditorGlobals.winNewPhase.phaseTitle
	
	
end sub


sub PhaseEditor_Init_New_Mesh ()

	'PhaseEditorGlobals.PhaseSequence.roomClass = PhaseEditorGlobals.winNewPhase.roomClass
	'PhaseEditorGlobals.PhaseSequence.phaseTitle = PhaseEditorGlobals.winNewPhase.phaseTitle
	
	dim as integer genClass
	genClass = PhaseEditorGlobals.winNewMesh.generatorClass
	
	dim as integer nGenerators
	PhaseDataGlobals.phaseSequence.nGenerators += 1
	nGenerators = PhaseDataGlobals.phaseSequence.nGenerators
	PhaseDataGlobals.phaseSequence.generator = reallocate(PhaseDataGlobals.phaseSequence.generator, sizeof(GeneratorClassType) * nGenerators)
	
	
	dim as integer newGenerator
	newGenerator = nGenerators - 1
	PhaseDataGlobals.phaseSequence.generator[newGenerator].title = PhaseEditorGlobals.generatorClass(genClass).title
	PhaseEditorGlobals.winSequencer.selGenerator = newGenerator
	PhaseDataGlobals.phaseSequence.generator[newGenerator].class = genClass
	
	if genClass = GC_BLOCK_TORUS then PhaseEditor_Init_Block_Torus newGenerator
	if genClass = GC_HEX_TUNNEL then PhaseEditor_Init_Hex_Tunnel newGenerator
	if genClass = GC_META_BALL_CLOUD then PhaseEditor_Init_Meta_Ball_Cloud newGenerator
	if genClass = GC_META_BALL_DISC then PhaseEditor_Init_Meta_Ball_Disc newGenerator

end sub


sub PhaseEditor_Init_New_Wave ()

	dim as integer waveClass
	waveClass = PhaseEditorGlobals.winNewWave.class
	
	dim as integer nWaves
	PhaseDataGlobals.phaseSequence.nWaves += 1
	nWaves = PhaseDataGlobals.phaseSequence.nWaves
	PhaseDataGlobals.phaseSequence.wave = reallocate(PhaseDataGlobals.phaseSequence.wave, sizeof(WaveClassType) * nWaves)
	
	dim as integer newWave
	newWave = nWaves - 1
	PhaseDataGlobals.phaseSequence.wave[newWave].title = PhaseEditorGlobals.waveClass(waveClass).title
	PhaseEditorGlobals.winSequencer.selWave = newWave
	PhaseDataGlobals.phaseSequence.wave[newWave].class = waveClass
	
	if newWave > 0 then PhaseDataGlobals.phaseSequence.wave[newWave].startTime = PhaseDataGlobals.phaseSequence.wave[newWave - 1].startTime + PhaseDataGlobals.phaseSequence.wave[newWave - 1].time
	
	if waveClass = WC_FLIES then PhaseEditor_Init_Wave_Flies newWave
	if waveClass = WC_BOSS_DRAGON then PhaseEditor_Init_Wave_BossDragon newWave


end sub