


sub PhaseEditor_Init_WaveClasses ()


	PhaseEditorGlobals.waveClass(WC_FLIES).title = "Flies"
	PhaseEditorGlobals.waveClass(WC_BOSS_DRAGON).title = "Boss_Dragon"
	
	dim i as integer
	
	for i = 0 to 99
		if PhaseEditorGlobals.waveClass(i).title <> "" then PhaseEditorGlobals.waveClassLast = i
	next

end sub



sub PhaseEditor_Init_WavePatterns ()


	PhaseEditorGlobals.wavePattern(WP_TYPE_I).title = "Type I"
	PhaseEditorGlobals.wavePattern(WP_ORBITAL).title = "Orbital"
	PhaseEditorGlobals.wavePattern(WP_ORBITAL_TYPE_II).title = "Orbital Type II"
	
	dim i as integer
	
	for i = 0 to 99
		if PhaseEditorGlobals.wavePattern(i).title <> "" then PhaseEditorGlobals.wavePatternLast = i
	next

end sub


sub PhaseEditor_Init_BulletClasses ()


	PhaseEditorGlobals.bulletClass(BC_TYPE_I).title = "Type I"
	
	dim i as integer
	
	for i = 0 to 99
		if PhaseEditorGlobals.bulletClass(i).title <> "" then PhaseEditorGlobals.bulletClassLast = i
	next

end sub


sub PhaseEditor_Init_BulletPatterns ()


	PhaseEditorGlobals.bulletPattern(BP_ONE_SHOT).title = "One Shot"
	PhaseEditorGlobals.bulletPattern(BP_BOMB).title = "Bomb"
	PhaseEditorGlobals.bulletPattern(BP_MULT_SHOT_AND_BOMB).title = "Mult Shot And Bomb"
	
	dim i as integer
	
	for i = 0 to 99
		if PhaseEditorGlobals.bulletPattern(i).title <> "" then PhaseEditorGlobals.bulletPatternLast = i
	next

end sub


sub PhaseEditor_Init_Wave_Flies (wID as integer)


	dim as WaveClassType ptr wave
	
	wave = @PhaseDataGlobals.phaseSequence.wave[wID]
	
	wave->class = PhaseEditorGlobals.winNewWave.class
	wave->pattern = 0
	wave->time = 90
	wave->speed = 15
	wave->nSpawn = 45
	wave->position.x = 0
	wave->position.y = 0
	wave->position.z = 0
	wave->positionOffset.x = 2
	wave->positionOffset.y = 2
	wave->positionOffset.z = 2
	wave->maxHealth = 100
	wave->rateOfFire = 60		'rounds per minute
	wave->bulletPattern = BP_ONE_SHOT
	wave->bulletClass = BC_TYPE_I
	
end sub


sub PhaseEditor_Init_Wave_BossDragon (wID as integer)


	dim as WaveClassType ptr wave
	
	wave = @PhaseDataGlobals.phaseSequence.wave[wID]
	
	wave->class = PhaseEditorGlobals.winNewWave.class
	wave->pattern = 0
	wave->time = 500
	wave->speed = 15
	wave->nSpawn = 1
	wave->position.x = 0
	wave->position.y = 0
	wave->position.z = 0
	wave->positionOffset.x = 0
	wave->positionOffset.y = 0
	wave->positionOffset.z = 0
	wave->maxHealth = 100
	wave->rateOfFire = 60		'rounds per minute
	wave->bulletPattern = BP_MULT_SHOT_AND_BOMB
	wave->bulletClass = BC_TYPE_I
	
end sub



sub PhaseEditor_Wave_Save (wave as WaveClassType ptr, filenum as integer)

	print #filenum, wave->title
	print #filenum, wave->time
	print #filenum, wave->startTime
	print #filenum, wave->speed
	print #filenum, wave->class
	print #filenum, wave->pattern
	print #filenum, wave->nSpawn
	print #filenum, wave->position.x
	print #filenum, wave->position.y
	print #filenum, wave->position.z
	print #filenum, wave->positionOffset.x
	print #filenum, wave->positionOffset.y
	print #filenum, wave->positionOffset.z
	print #filenum, wave->maxHealth
	print #filenum, wave->rateOfFire
	print #filenum, wave->bulletPattern
	print #filenum, wave->bulletClass
	

end sub