type PhasePauseGlobalsType


	initialized	as byte
	exitCode	as byte

	waitTicks	as integer
	
	nSliders		as integer
	gradSlider(20)	as GradSliderType
	
	titleMID		as integer
	titleDL			as integer
	titleZoom		as single
	titleZoomSpeed	as single
	titleAngle		as single
	titleStartZoom	as single
	titleFade		as integer
	
	pausedMID		as integer
	
	destination		as integer
	
	mousex			as integer
	mousey			as integer
	mouseLeft		as integer
	mouseRight		as integer
	
	curWindow		as integer

	winAlpha(99)	as single
	winActive(99)	as integer
	winLock(99)		as integer
	
	windowLock		as integer
	
	
end type



DECLARE sub PhasePause_DeInit ()
DECLARE sub PhasePause_Initialize ()
DECLARE sub PhasePause_LaunchApp ()
DECLARE sub PhasePause_MainLoop ()
DECLARE sub PhasePause_ProcessInputs ()
DECLARE sub PhasePause_Render ()
DECLARE sub PhasePause_Shutdown ()

declare sub PhasePause_Render_Gui_Layer ()
declare sub PhasePause_Render_Gui_Main ()

dim shared PhasePauseGlobals as PhasePauseGlobalsType

