sub PhaseMenu_Render_Gui_HighScores ()


	dim as integer win, active
	dim as single alpha
	win = WIN_HIGH_SCORES
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy, i
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer buttonheight, curY
	dim as integer winX0, winY0, winW, winH
	winW = 360
	winH = 372
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	
	PhaseEditor_Render_Gui_WindowGame winX0, winY0, winX0 + winW, winY0 + winH, PEC_TEXTBOX_BG, PMC_WINDOW_BG_DARK, win
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, winY0 + 5, "HIGH SCORES"
	font_draw winX0 + 5, winY0 + 5, "HIGH SCORES"
	
	buttonHeight = 22
	curY = winY0 + 30
	
	dim as integer totalPoints, w, h, ii
	dim as string gcTitle
	
	totalPoints = 0
	for i = 0 to 13
		totalPoints += PhasePlayerGlobals.player.highScores(i).points
	next
	
	if totalPoints > 0 then
		for i = 0 to 13
		
			PhaseEditor_SetColor PEC_TEXTBOX_BG, win
			
			if PhasePlayerGlobals.player.highScores(i).points > 0 then 
			
					gcTitle = PhasePlayerGlobals.player.highScores(i).name
					
					font_xy w, h, gcTitle
					if w > 210 then
						for ii = 1 to len(gcTitle)
							font_xy w, h, gcTitle
							if w > 210 then
								gcTitle = left(gcTitle, len(gcTitle) - 1)
							else
								gcTitle += "..."
								goto contin3
							end if
						next
					end if
					
contin3:
				font_draw winx0 + 5, curY, gcTitle
				font_draw winx0 + 5, curY, gcTitle
				
				PhaseEditor_Render_Gui_Button str(int(PhasePlayerGlobals.player.highScores(i).points + PhasePlayerGlobals.player.highScores(i).points * PhasePlayerGlobals.player.highScores(i).timeBonus)), cx + 70, curY - 3, 100, BUTTON_CENTER, win
				if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
					PhaseEditorGlobals.waitTicks = system_ticks + 200
					PhaseEditorGlobals.winLock(win) = 1
					PhaseEditorGlobals.winActive(WIN_HS_DATA) = 1
					PhaseMenuGlobals.winHSData.hs = i
					
					if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
						PhasePlayerGlobals.musicChannel(MH_COCK) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_COCK))
						FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_COCK), PhaseMenuGlobals.winOptions.sfxVol
					end if
				end if
			else
				font_draw winx0 + 5, curY, "No Score"
				font_draw winx0 + 5, curY, "No Score"
				
				PhaseEditor_Render_Gui_Button "-----", cx + 70, curY - 3, 100, BUTTON_CENTER, win
			end if
			
			curY += buttonHeight
			
		next
	else
	
		PhaseEditor_SetColor PEC_TEXTBOX_BG, win
		gcTitle = "No Saved Scores"
		font_xy w, h, gcTitle
		
		font_draw cx - w / 2, curY, gcTitle
		font_draw cx - w / 2, curY, gcTitle
	end if
	
	
	PhaseEditor_Render_Gui_Button "MAIN", cx - 35, winY0 + winH - 25, 70, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_MAIN) = 0
		
		if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
			PhasePlayerGlobals.musicChannel(MH_COCK) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_COCK))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_COCK), PhaseMenuGlobals.winOptions.sfxVol
		end if
	end if

	
end sub
