sub PhaseEditor_Render_Gui_NewWave ()


	dim as integer win, active
	dim as single alpha
	win = WIN_NEW_WAVE
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy, i
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer winX0, winY0, winW, winH
	winW = 300
	winH = 100
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	dim as integer buttonX
	buttonX = 155
	
	PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, winY0 + 5, "NEW WAVE"
	font_draw winX0 + 5, winY0 + 5, "NEW WAVE"
	
	dim as string gcTitle
	dim as integer rowHeight, curY
	
	rowHeight = 24
	
	curY = winY0 + 30
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "Class:"
	PhaseEditor_Render_Gui_Button PhaseEditorGlobals.waveClass(PhaseEditorGlobals.winNewWave.class).title, winX0 + 120, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseEditorGlobals.winNewWave.class
		PhaseEditorGlobals.winSelectTable.title = "Select Wave Class"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = ""
		for i = 0 to PhaseEditorGlobals.waveClassLast
			PhaseEditorGlobals.winSelectTable.Options += "<" + PhaseEditorGlobals.waveClass(i).title + ">"
		next
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	
	PhaseEditor_Render_Gui_Button "CREATE", cx - 75, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and (PhaseEditorGlobals.mouseLeft = 1 or glfwGetKey(GLFW_KEY_ENTER) = 1) then
		if PhaseEditorGlobals.winNewWave.class > -1 then
			active = 0: PhaseEditorGlobals.winActive(win) = active
			PhaseEditorGlobals.winLock(WIN_SEQUENCER) = 0
			PhaseEditor_Init_New_Wave
		end if
	end if
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 10, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_SEQUENCER) = 0
	end if
	
end sub



sub PhaseEditor_Window_Init_NewWave ()

	PhaseEditorGlobals.winNewWave.class = 0
	
end sub