sub PhaseEditor_Render_Gui_NumberBoxWindow ()

	dim as integer dropout
	dim as integer win, active
	dim as single alpha
	win = WIN_NUMBER_BOX
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = 0
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	
	dim as integer winX0, winY0, winW, winH
	winW = 300
	winH = 95
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, winY0 + 5, PhaseEditorGlobals.winNumberBox.title
	font_draw winX0 + 5, winY0 + 5, PhaseEditorGlobals.winNumberbox.title
	
	dim as single ret
	dim as integer pass
	dim as string text
	
	text = PhaseEditorGlobals.winNumberBox.text
	
	if keyHandler.key <> 0 then
		pass = 1
		if keyHandler.key = 9 then
			pass = 0
			if len(text) > 0 then
				text = left(text, len(text) - 1)
				PhaseEditorGlobals.winNumberBox.text = text
			end if
		end if
		if keyHandler.key = 13 then
			pass = 0
			dropout = 1
			PhaseEditorGlobals.winNumberBox.value = val(PhaseEditorGlobals.winNumberBox.text)
			*PhaseEditorGlobals.winNumberBox.returnValue = PhaseEditorGlobals.winNumberBox.value
			if PhaseEditorGlobals.winNumberBox.returnWindow = WIN_MESH_PROPERTIES then PhaseEditorGlobals.winMeshProperties.forceRegen = 1
		end if
		if pass = 1 and len(text) < PhaseEditorGlobals.winNumberBox.charLimit then
			if keyHandler.key = 46 then text += chr(keyHandler.key)
			if keyHandler.key > 47 and keyHandler.key < 58 then text += chr(keyHandler.key)
		end if
	end if
	
	PhaseEditorGlobals.winNumberBox.text = text
	
	dim as integer rowHeight, curY
	rowHeight = 24
	curY = winY0 + 30
	
	PhaseEditor_Render_Gui_Textbox text, cx - PhaseEditorGlobals.winNumberBox.charLimit * 8, curY - 3, PhaseEditorGlobals.winNumberBox.charLimit * 8 * 2, win
	
	PhaseEditor_Render_Gui_Button "OK", cx - 75, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		dropout = 1
		PhaseEditorGlobals.winNumberBox.value = val(PhaseEditorGlobals.winNumberBox.text)
		*PhaseEditorGlobals.winNumberBox.returnValue = PhaseEditorGlobals.winNumberBox.value
		if PhaseEditorGlobals.winNumberBox.returnWindow = WIN_MESH_PROPERTIES then PhaseEditorGlobals.winMeshProperties.forceRegen = 1
	end if
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 10, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		dropout = 1
	end if
	
	if dropout = 1 then 
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(PhaseEditorGlobals.winNumberBox.returnWindow) = 0
	end if
	
end sub



sub PhaseEditor_Window_Init_NumberBoxWindow (value as single, limit as integer)

	PhaseEditorGlobals.winNumberBox.text = str(value)
	PhaseEditorGlobals.winNumberBox.value = value
	PhaseEditorGlobals.winNumberBox.charLimit = limit
	
end sub