sub PhaseMenu_Render_Gui_Options ()


	dim as integer win, active
	dim as single alpha
	win = WIN_OPTIONS
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy, i
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer winX0, winY0, winW, winH
	winW = 300
	winH = 280 + 48
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	'PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	PhaseEditor_Render_Gui_WindowGame winX0, winY0, winX0 + winW, winY0 + winH, PEC_TEXTBOX_BG, PMC_WINDOW_BG_DARK, win
	
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, winY0 + 5, "OPTIONS"
	font_draw winX0 + 5, winY0 + 5, "OPTIONS"
	
	
	if PhaseMenuGlobals.winOptions.musicOnReset > -1 then
		PhasePlayerGlobals.player.musicPlaying = 0
		PhaseMenuGlobals.winOptions.musicOn = PhaseMenuGlobals.winOptions.musicOnReset
		if PhaseMenuGlobals.winOptions.musicOnReset = 0 then fsound_stopsound PhasePlayerGlobals.musicChannel(MH_SONG2)
	end if
	
	PhaseMenuGlobals.winOptions.musicOnReset = -1
	
	dim as integer rowHeight, curY, buttonX
	rowHeight = 24
	curY = winY0 + 30
	
	buttonX = 150
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Difficulty:"
	if PhaseMenuGlobals.winOptions.difficulty = 0 then PhaseEditor_Render_Gui_Button "Easy", winX0 + buttonX, curY - 3, 0, 0, win
	if PhaseMenuGlobals.winOptions.difficulty = 1 then PhaseEditor_Render_Gui_Button "Medium", winX0 + buttonX, curY - 3, 0, 0, win
	if PhaseMenuGlobals.winOptions.difficulty = 2 then PhaseEditor_Render_Gui_Button "Hard", winX0 + buttonX, curY - 3, 0, 0, win
	if PhaseMenuGlobals.winOptions.difficulty = 3 then PhaseEditor_Render_Gui_Button "No Mercy", winX0 + buttonX, curY - 3, 0, 0, win
	
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseMenuGlobals.winOptions.difficulty
		PhaseEditorGlobals.winSelectTable.title = "Select Difficulty Level"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = "<Easy><Medium><Hard><No Mercy>"
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Bit Depth:"
	if PhaseMenuGlobals.winOptions.bitDepth = 0 then PhaseEditor_Render_Gui_Button "16", winX0 + buttonX, curY - 3, 0, 0, win
	if PhaseMenuGlobals.winOptions.bitDepth = 1 then PhaseEditor_Render_Gui_Button "32", winX0 + buttonX, curY - 3, 0, 0, win
	
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseMenuGlobals.winOptions.bitDepth
		PhaseEditorGlobals.winSelectTable.title = "Select Bit Depth"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = "<16><32>"
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	dim as single d0
	dim as integer a
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Resolution:"
	for i = 0 to PhaseMenuGlobals.nVideoModes - 1
		if PhaseMenuGlobals.videoMode(i).height >= 400 then
		if PhaseMenuGlobals.videoMode(i).redBits + PhaseMenuGlobals.videoMode(i).greenBits + PhaseMenuGlobals.videoMode(i).blueBits = 24  and PhaseMenuGlobals.winOptions.bitDepth = 1 then a += 1
		if PhaseMenuGlobals.videoMode(i).redBits + PhaseMenuGlobals.videoMode(i).greenBits + PhaseMenuGlobals.videoMode(i).blueBits = 16  and PhaseMenuGlobals.winOptions.bitDepth = 0 then a += 1
		if PhaseMenuGlobals.winOptions.resolution = a then
			PhaseMenuGlobals.winOptions.res.x = PhaseMenuGlobals.videoMode(i).width
			PhaseMenuGlobals.winOptions.res.y = PhaseMenuGlobals.videoMode(i).height
			PhaseMenuGlobals.winOptions.res.z = PhaseMenuGlobals.videoMode(i).redBits + PhaseMenuGlobals.videoMode(i).greenBits + PhaseMenuGlobals.videoMode(i).blueBits
			if PhaseMenuGlobals.winOptions.res.z = 24 then PhaseMenuGlobals.winOptions.res.z = 32
		end if
		end if
	next
	
	PhaseEditor_Render_Gui_Button str(PhaseMenuGlobals.winOptions.res.x) + "x" + str(PhaseMenuGlobals.winOptions.res.y), winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseMenuGlobals.winOptions.resolution
		PhaseEditorGlobals.winSelectTable.title = "Select Resolution"
		PhaseEditorGlobals.winSelectTable.returnOffset = 1
		PhaseEditorGlobals.winSelectTable.Options = ""
		for i = 0 to PhaseMenuGlobals.nVideoModes - 1
			if PhaseMenuGlobals.videoMode(i).height >= 400 then
			if PhaseMenuGlobals.videoMode(i).redBits + PhaseMenuGlobals.videoMode(i).greenBits + PhaseMenuGlobals.videoMode(i).blueBits = 24  and PhaseMenuGlobals.winOptions.bitDepth = 1 then PhaseEditorGlobals.winSelectTable.Options += "<" + str(PhaseMenuGlobals.videoMode(i).Width) + "x" + str(PhaseMenuGlobals.videoMode(i).Height)+ ">"
			if PhaseMenuGlobals.videoMode(i).redBits + PhaseMenuGlobals.videoMode(i).greenBits + PhaseMenuGlobals.videoMode(i).blueBits = 16  and PhaseMenuGlobals.winOptions.bitDepth = 0 then PhaseEditorGlobals.winSelectTable.Options += "<" + str(PhaseMenuGlobals.videoMode(i).Width) + "x" + str(PhaseMenuGlobals.videoMode(i).Height)+ ">"
			end if
		next
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Full Screen:"
	if PhaseMenuGlobals.winOptions.fullScreen = 0 then PhaseEditor_Render_Gui_Button "NO", winX0 + buttonX, curY - 3, 0, 0, win
	if PhaseMenuGlobals.winOptions.fullScreen = 1 then PhaseEditor_Render_Gui_Button "YES", winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseMenuGlobals.winOptions.fullScreen
		PhaseEditorGlobals.winSelectTable.title = "Full Screen"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = "<NO><YES>"
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Music:"
	if PhaseMenuGlobals.winOptions.musicOn = 0 then PhaseEditor_Render_Gui_Button "OFF", winX0 + buttonX, curY - 3, 0, 0, win
	if PhaseMenuGlobals.winOptions.musicOn = 1 then PhaseEditor_Render_Gui_Button "ON", winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseMenuGlobals.winOptions.musicOnReset
		PhaseEditorGlobals.winSelectTable.title = "Music"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = "<OFF><ON>"
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Music Volume:"
	PhaseEditor_Render_Gui_IconButton winX0 + buttonX, curY, 140, 10, win
	if active and PhaseEditorGlobals.mouseLeft then
		d0 = (PhaseEditorGlobals.mouseX - winX0 - buttonX) / 140
		if d0 < 0 then d0 = 0
		if d0 > 1 then d0 = 1
		PhaseMenuGlobals.winOptions.musicVol = d0 * 256
	end if
	PhaseEditor_Render_Gui_Button "", winX0 + buttonX + 130 * PhaseMenuGlobals.winOptions.musicVol / 256, curY - 3, 10, 0, win
	
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Sound FX:"
	if PhaseMenuGlobals.winOptions.sfxOn = 0 then PhaseEditor_Render_Gui_Button "OFF", winX0 + buttonX, curY - 3, 0, 0, win
	if PhaseMenuGlobals.winOptions.sfxOn = 1 then PhaseEditor_Render_Gui_Button "ON", winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseMenuGlobals.winOptions.sfxOn
		PhaseEditorGlobals.winSelectTable.title = "Sound FX"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = "<OFF><ON>"
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Sound FX Volume:"
	PhaseEditor_Render_Gui_IconButton winX0 + buttonX, curY, 140, 10, win
	if active and PhaseEditorGlobals.mouseLeft then
		d0 = (PhaseEditorGlobals.mouseX - winX0 - buttonX) / 140
		if d0 < 0 then d0 = 0
		if d0 > 1 then d0 = 1
		PhaseMenuGlobals.winOptions.sfxVol = d0 * 256
	end if
	PhaseEditor_Render_Gui_Button "", winX0 + buttonX + 130 * PhaseMenuGlobals.winOptions.sfxVol / 256, curY - 3, 10, 0, win
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Mouse Sensitivity:"
	PhaseEditor_Render_Gui_IconButton winX0 + buttonX, curY, 140, 10, win
	if active and PhaseEditorGlobals.mouseLeft then
		d0 = (PhaseEditorGlobals.mouseX - winX0 - buttonX) / 140
		if d0 < 0 then d0 = 0
		if d0 > 1 then d0 = 1
		PhaseMenuGlobals.winOptions.sensitivity = d0 * 256
	end if
	PhaseEditor_Render_Gui_Button "", winX0 + buttonX + 130 * PhaseMenuGlobals.winOptions.sensitivity / 256, curY - 3, 10, 0, win
	
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, curY, "Invert Mouse:"
	if PhaseMenuGlobals.winOptions.invertMouse = 0 then PhaseEditor_Render_Gui_Button "OFF", winX0 + buttonX, curY - 3, 0, 0, win
	if PhaseMenuGlobals.winOptions.invertMouse = 1 then PhaseEditor_Render_Gui_Button "ON", winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseMenuGlobals.winOptions.invertMouse
		PhaseEditorGlobals.winSelectTable.title = "Invert Mouse"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = "<OFF><ON>"
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	
	
	
	PhaseMenuGlobals.restart = 0
	PhaseEditor_Render_Gui_Button "SAVE", cx - 75, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ENTER) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_MAIN) = 0
		
		if PhaseMenuGlobals.winOptions.res.x <> OpenGLProperties.SCR_WIDTH then PhaseMenuGlobals.restart = 1
		if PhaseMenuGlobals.winOptions.res.y <> OpenGLProperties.SCR_HEIGHT then PhaseMenuGlobals.restart = 1
		if PhaseMenuGlobals.winOptions.bitDepth = 0 and OpenGLProperties.SCR_BITS = 32 then PhaseMenuGlobals.restart = 1
		if PhaseMenuGlobals.winOptions.bitDepth = 1 and OpenGLProperties.SCR_BITS = 16 then PhaseMenuGlobals.restart = 1
		if PhaseMenuGlobals.winOptions.fullscreen = 0 and OpenGLProperties.SCR_FULLSCREEN = GLFW_FULLSCREEN then PhaseMenuGlobals.restart = 1
		if PhaseMenuGlobals.winOptions.fullscreen = 1 and OpenGLProperties.SCR_FULLSCREEN = GLFW_WINDOW then PhaseMenuGlobals.restart = 1
		
		open "configVars.dat" for output as #1
			print #1, PhaseMenuGlobals.winOptions.res.x
			print #1, PhaseMenuGlobals.winOptions.res.y
			if PhaseMenuGlobals.winOptions.bitDepth = 0 then print #1, 16
			if PhaseMenuGlobals.winOptions.bitDepth = 1 then print #1, 32
			print #1, PhaseMenuGlobals.winOptions.fullscreen
			print #1, PhaseMenuGlobals.winOptions.musicOn
			print #1, PhaseMenuGlobals.winOptions.sfxOn
			print #1, PhaseMenuGlobals.winOptions.musicVol
			print #1, PhaseMenuGlobals.winOptions.sfxVol
			print #1, PhaseMenuGlobals.winOptions.sensitivity
			print #1, PhaseMenuGlobals.winOptions.invertMouse
			print #1, PhaseMenuGlobals.winOptions.difficulty
		close #1
		
		if PhaseMenuGlobals.winOptions.musicOn = 0 then
			fsound_stopsound PhasePlayerGlobals.musicChannel(MH_SONG2)
			PhasePlayerGlobals.player.musicPlaying = 0
		end if
		
		if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
			PhasePlayerGlobals.musicChannel(MH_COCK) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_COCK))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_COCK), PhaseMenuGlobals.winOptions.sfxVol
		end if
	end if
	
	
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 10, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_MAIN) = 0
		
		if PhaseMenuGlobals.winOptions.musicOn <> PhaseMenuGlobals.winOptions.musicOnInitial then
			PhasePlayerGlobals.player.musicPlaying = 0
			PhaseMenuGlobals.winOptions.musicOn = PhaseMenuGlobals.winOptions.musicOnInitial
			if PhaseMenuGlobals.winOptions.musicOn = 0 then fsound_stopsound PhasePlayerGlobals.musicChannel(MH_SONG2)
		end if
	
		
		if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
			PhasePlayerGlobals.musicChannel(MH_COCK) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_COCK))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_COCK), PhaseMenuGlobals.winOptions.sfxVol
		end if
	end if
end sub
