
Declare operator + ( Byval lhs As Vector3D, Byval rhs As Vector3D ) As Vector3D
Declare operator - ( Byref lhs as Vector3d ) as Vector3d
Declare operator - ( Byval lhs As Vector3D, Byval rhs As Vector3D ) As Vector3D
Declare operator - ( Byval lhs As Vector3D, Byval rhs As Vector4D ) As Vector3D
Declare operator - ( Byval lhs As Vector3D, Byval rhs As Single ) As Vector3D
Declare operator * ( Byval lhs As Vector3D, Byval rhs As Vector3D ) As Vector3D
Declare operator * ( Byval lhs As Vector3D, Byval rhs As Single ) As Vector3D
Declare operator * ( Byval lhs As Vector3D, Byval rhs As Vector4D ) As Vector3D
Declare operator / ( Byval lhs As Vector3D, Byval rhs As Vector3D ) As Vector3D
Declare operator / ( Byval lhs As Vector3D, Byval rhs as Single ) As Vector3D




operator + ( Byval lhs As Vector3D, Byval rhs As Vector3D ) As Vector3D

Return Type<Vector3D>( lhs.x + rhs.x, lhs.y + rhs.y,  lhs.z + rhs.z)

End operator


operator - ( Byref lhs As Vector3d ) As Vector3d

Return Type<Vector3D>(-lhs.x, -lhs.y, -lhs.z )

End operator 


operator - ( Byval lhs As Vector3D, Byval rhs As Vector3D ) As Vector3D

Return Type<Vector3D>(lhs.x - rhs.x, lhs.y - rhs.y, lhs.z - rhs.z )

End operator


operator - ( Byval lhs As Vector3D, Byval rhs As Vector4D ) As Vector3D

Return Type<Vector3D>(lhs.x - rhs.x, lhs.y - rhs.y, lhs.z - rhs.z )

End operator


operator - ( Byval lhs As Vector3D, Byval rhs As Single ) As Vector3D

Return Type<Vector3D>(lhs.x - rhs, lhs.y - rhs, lhs.z - rhs )

End operator


operator * ( Byval lhs As Vector3D, Byval rhs As Vector3D ) As Vector3D

Return Type<Vector3D>(lhs.x * rhs.x, lhs.y * rhs.y, lhs.z * rhs.z )

End operator


operator * ( Byval lhs As Vector3D, Byval rhs As Vector4D ) As Vector3D

Return Type<Vector3D>(lhs.x * rhs.x, lhs.y * rhs.y, lhs.z * rhs.z )

End operator

operator * ( Byval lhs As Vector4D, Byval rhs As single ) As Vector4D

Return Type<Vector4D>(lhs.x * rhs, lhs.y * rhs, lhs.z * rhs, lhs.w * rhs )

End operator


'For multiplying by a scalar... such as magnitude
operator * ( Byval lhs As Vector3D, Byval rhs As Single ) As Vector3D

Return Type<Vector3D>(lhs.x * rhs, lhs.y * rhs, lhs.z * rhs )

End operator




'Just for good measure...
operator / ( Byval lhs As Vector3D, Byval rhs As Vector3D ) As Vector3D

Return Type<Vector3D>(lhs.x / rhs.x, lhs.y / rhs.y, lhs.z / rhs.z )

End operator

'For dividng by a scalar... such as magnitude
operator / ( Byval lhs As Vector3D, Byval rhs As Single ) As Vector3D

Return Type<Vector3D>(lhs.x / rhs, lhs.y / rhs, lhs.z / rhs )

End operator


operator Vector3D.cast( ) As Vector4D
    return Type<Vector4D>(x, y, z, 0)
End operator

