DECLARE sub system_2dplane_clear ()
DECLARE sub system_2dplane_set_full ()
DECLARE Sub system_upd_fpsr ()
DECLARE Sub System_Process_Adjustment_Inputs ()
DECLARE sub System_Process_Key_Strokes ()
declare function system_time () as single

' timer data
dim shared as integer fp, fps, system_nextticks, system_ticks, keystroke_next_ticks, system_ticksPassed
dim shared as single fpsr, system_virtualTime

dim shared as single tempx, tempy, tempz

type KeyHandlerType
	nextTicks	as integer
	key			as integer
end type
	
dim shared keyHandler as KeyHandlerType

Shadow_Infinity = .99999

#DEFINE	SHIP_ALIAS 0
#DEFINE SHIP_DELETER 1


function system_time () as single

	dim t as single
	
	t = glfwGetTime
	
	t -= system_virtualTime
	
	return t
	
end function



sub system_2dplane_clear()
    
    glViewport 0, 0, OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT
	'glViewport 0, OpenGLProperties.SCR_BORDER, OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT - OpenGLProperties.SCR_BORDER * 2
	
	glMatrixMode GL_PROJECTION
    glPopMatrix
    glMatrixMode GL_MODELVIEW
    
    glEnable GL_LIGHTING
    glEnable GL_DEPTH_TEST
	
	glLoadIdentity
	
    
end sub  



sub system_2dplane_set_full()
    
    glMatrixMode GL_PROJECTION
    glPushMatrix
    glLoadIdentity
    glMatrixMode GL_MODELVIEW  
   
    glDisable GL_DEPTH_TEST
    glDisable GL_LIGHTING
    glLoadIdentity
    
    glViewport 0, 0, OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT
	'glViewport 0, OpenGLProperties.SCR_BORDER, OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT - OpenGLProperties.SCR_BORDER * 2
    gluOrtho2d 0,OpenGLProperties.SCR_WIDTH -1, OpenGLProperties.SCR_HEIGHT -1,0
	'gluOrtho2d 0,OpenGLProperties.SCR_WIDTH -1, OpenGLProperties.SCR_HEIGHT - OpenGLProperties.SCR_BORDER -1,0'OpenGLProperties.SCR_BORDER
    
end sub



sub System_Process_Adjustment_Inputs ()

	dim as single w
	
	w = fpsr * .1
	if glfwGetKey(asc("S")) then tempx -= w
	if glfwGetKey(asc("F")) then tempx += w
	
	if glfwGetKey(asc("E")) then tempy -= w
	if glfwGetKey(asc("D")) then tempy += w

	if glfwGetKey(asc("W")) then tempz -= w
	if glfwGetKey(asc("R")) then tempz += w
	
	locate 1,1: print tempx, tempy, tempz

end sub


sub System_Process_Key_Strokes ()

	keyHandler.key = 0
	if keyHandler.nextTicks > system_ticks then exit sub
	
	dim as integer pass, c
	
	pass = 0
	
	if glfwGetKey(GLFW_KEY_BACKSPACE) then pass = 9
	if glfwGetKey(GLFW_KEY_ENTER) then pass = 13
	
	for c = 32 to 192
		if glfwGetKey(c) then pass = c
	next
	
	if pass > 0 then
		keyHandler.nextTicks = system_time * 1000 + 140
		keyHandler.key = pass
	end if
	
end sub


sub system_upd_fpsr ()

	dim as integer tickspassed
	
	tickspassed = system_ticks
	system_ticks = system_time * 1000
	
	tickspassed = system_ticks - tickspassed
	system_ticksPassed = tickspassed
	fpsr += (tickspassed / 16 - fpsr) * .2
	
	'fpsr += (tickspassed / 20 - fpsr) * .5

	fp = fp + 1
	if system_ticks > system_nextticks then
		system_nextticks = system_ticks + 1000
		fps = fp
		fp = 0
	end if
	
	'print fpsr
	'if fpsr > 1 then fpsr = 1
	
	'if fpsr < 0 then fpsr = 0
	sleep 10 '/ fpsr + 10
	
end sub



